Attribute VB_Name = "Module1"
' vb@rchiv - Das groe Visual-Basic Archiv
' Tools & Components - Entwicklerkomponenten fr VB-32 Bit
'
' Copyright 2000-2003 Dieter Otter
'
' Der Programmcode darf fr eigene Zwecke verwendet werden.
' Es ist nicht erlaubt Inhalte des Projektes ohne unserer
' Zustimmung zum Download anzubieten.
'
' Die Beispielskripte sind Computerprogramme, die gem
' des 2 Abs. 1 Nr. 69 aff. UrhG den urheberrechtlichen
' Schutz geniessen und drfen nicht fr eigene ausgegeben
' werden.
'
' Dieter Otter
' Software-Entwicklung & Vertrieb
' info@vbarchiv.de
' http://www.vbarchiv.de
' http://www.visualbasic-archiv.de
'
' info@tools4vb.de
' http://www.tools4vb.de
'======================================================
Option Explicit

' Bentigte API-Deklarationen
Private Declare Function GetClassName Lib "user32" _
  Alias "GetClassNameA" ( _
  ByVal hWnd As Long, _
  ByVal lpClassName As String, _
  ByVal nMaxCount As Long) As Long

Private Declare Function GetWindow Lib "user32" ( _
  ByVal hWnd As Long, _
  ByVal wCmd As Long) As Long

Public Declare Function CallWindowProc Lib "user32" _
  Alias "CallWindowProcA" ( _
  ByVal lpPrevWndFunc As Long, _
  ByVal hWnd As Long, _
  ByVal Msg As Long, _
  ByVal wParam As Long, _
  ByVal lParam As Long) As Long

Public Declare Function SetWindowLong Lib "user32" _
  Alias "SetWindowLongA" ( _
  ByVal hWnd As Long, _
  ByVal nIndex As Long, _
  ByVal dwNewLong As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" _
  Alias "RtlMoveMemory" ( _
  Destination As Any, _
  Source As Any, _
  ByVal Length As Long)

Private Const GWL_WNDPROC = (-4)
Private Const GW_HWNDNEXT = 2
Private Const GW_CHILD = 5
Private Const WM_MOUSEACTIVATE = &H21
Private Const WM_RBUTTONDOWN = &H204


' Merkvariable fr unsere ursprngliche Window-Prozedur
Private oldWndProc As Long
' Ermittelt das Fensterhandle des WebBrowser-Controls,
' welches wir subclassen mssen
'
' Erwartet wird zunchst das Handle der Form, auf dem
' sich das WebBrowser-Control befindet
Public Function GetWebBrowserHWnd( _
  ByVal hWndMain As Long) As Long

  Dim hWnd As Long
  Dim sClassName As String
  Dim nResult As Long
  
  ' Alle Child-Windows der MainForm durchlaufen und
  ' nach dem Klassennamen "Shell Embedding" suchen
  ' Wenn wir einen solchen Klassennamen finden,
  ' haben wir das gesuchte Fensterhandle.
  hWnd = GetWindow(hWndMain, GW_CHILD)
  Do While hWnd <> 0
    ' Klassennamen ermitteln...
    sClassName = Space$(256)
    nResult = GetClassName(hWnd, sClassName, Len(sClassName))
    
    ' ... und prfen...
    sClassName = Left$(sClassName, nResult)
    If sClassName = "Shell Embedding" Then
      ' ... und gefunden
      GetWebBrowserHWnd = hWnd
      Exit Do
    End If
    
    ' Nchstes Child-Window ermitteln
    hWnd = GetWindow(hWnd, GW_HWNDNEXT)
  Loop
End Function

' Subclassing beginnen
Public Sub StartSubClass(ByVal hWnd As Long)
  oldWndProc = SetWindowLong(hWnd, GWL_WNDPROC, _
    AddressOf WndProc)
End Sub

Public Sub EndSubClass(ByVal hWnd As Long)
  ' Fensternachrichten wieder an die ursprngliche
  ' WindowProcedur leiten
  Call SetWindowLong(hWnd, GWL_WNDPROC, oldWndProc)
End Sub

' Fensternachrichten auswerten und nach
' der WM_MOUSEACTIVATE "Ausschau halten"
Public Function WndProc(ByVal hWnd As Long, _
  ByVal uMsg As Long, _
  ByVal wParam As Long, _
  ByVal lParam As Long) As Long
    
  Dim nValue As Long
  Dim bForward As Boolean
  
  bForward = True
  Select Case uMsg
    Case WM_MOUSEACTIVATE
      ' Aha! Mausaktivitt
      ' Prfen, ob Rechtsklick
      nValue = HiWord(lParam)
      If nValue = WM_RBUTTONDOWN Then
        ' Eigenes Kontextmen anzeigen
        Form1.PopupMenu Form1.MenuPopUp
        bForward = False
      End If
  End Select
  
  ' Nachricht an die ursprngliche WindowProzedur
  ' weiterleiten
  If bForward Then
    WndProc = CallWindowProc(oldWndProc, hWnd, uMsg, _
      wParam, lParam)
  End If
End Function

' Hilfsfunktion
Private Function HiWord(ByRef uParam As Long) As Long
  Dim n As Long
   
  n = 0
  CopyMemory ByVal VarPtr(n), ByVal VarPtr(uParam) + 2, 2
  HiWord = n
End Function

